/* ax25tbl.c 1994.5.13 */

#include <time.h>
#include "pbdef.h"
#include "ax25.h"

struct stevt evttbl[][16] = {
/* 0 E_ICP */
   {{DM, S1},{-1, S2 },{FRMR,S3 },{DM, S1},
    {RR, S5},{RNR,S5 },{RR,  S7 },{RNR,S8 },
    {RR, S9},{RNR,S10},{RR,  S11},{RNR,S12},
    {RR,S13},{RNR,S14},{RR,  S9 },{RNR,S16}},
/* 1 E_IC */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S5},{I,S7},{RNR,S8},
    {RR,S9},{RNR,S10},{RNR,S11},{RR,S12},
    {RNR,S13},{RNR,S14},{RR,S9},{RNR,S16}},
/* 2 E_RRCP */
   {{DM,S1},{-1,S2}, {FRMR,S3},{DM,S1},
    {RR,S5},{RR,S6}, {RR,S7},  {RNR,S8},
    {RR,S5},{RNR,S8},{RNR,S7}, {RR,S7},
    {RNR,S11},{RNR,S14},{RR,S6},{RNR,S14}},
/* 3 E_RRC */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S11},{I,S7},
    {I,S11},{I,S14},{I,S6},{I,S14}},
/* 4 E_REJCP */
   {{DM,S1},{-1,S2}, {FRMR,S3},{DM,S1},
    {RR,S5},{RR,S6}, {RR,S7},  {RNR,S8},
    {RR,S5},{RNR,S8},{RNR,S7}, {RR,S7},
    {RNR,S11},{RNR,S14},{RR,S6},{RNR,S14}},
/* 5 E_REJC */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S11},{I,S7},
    {I,S11},{I,S14},{I,S6},{I,S14}},
/* 6 E_RNRCP */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 7 E_RNRC */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 8 E_SABM */
   {{UA,S5},{UA,S5},{UA,S5},{DM,S1},
    {UA,S5},{UA,S5},{UA,S5},{UA,S8},
    {UA,S5},{UA,S8},{UA,S8},{UA,S5},
    {UA,S8},{UA,S8},{UA,S5},{UA,S5}},
/* 9 E_DISC */
   {{DM,S1},{DM,S1},{UA,S1},{UA,S1},
    {UA,S1},{UA,S1},{UA,S1},{UA,S1},
    {UA,S1},{UA,S1},{UA,S1},{UA,S1},
    {UA,S1},{UA,S1},{UA,S1},{UA,S1}},
/* 10 E_RRRF */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S8},{I,S5},
    {I,S8},{I,S14},{I,S6},{I,S14}},
/* 11 E_RRR */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S11},{I,S7},
    {I,S11},{I,S14},{I,S6},{I,S14}},
/* 12 E_REJRF */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S8},{I,S5},
    {I,S8},{I,S14},{I,S6},{I,S14}},
/* 13 E_REJR */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},
    {I,S5},{I,S6},{I,S5},{I,S8},
    {I,S5},{I,S8},{I,S11},{I,S7},
    {I,S11},{I,S14},{I,S6},{I,S14}},
/* 14 E_RNRRF */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 15 E_RNRR */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 16 E_UA */
   {{-1,S1}, {-1,S5}, {-1,S3}, {-1,S1},
    {-1,S5}, {-1,S6}, {-1,S7}, {-1,S8},
    {-1,S9}, {-1,S10},{-1,S11},{-1,S12},
    {-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 17 E_DM */
   {{-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1}},
/* 18 E_FRMR */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 19 E_START */
   {{_CMD|PF|SABM,S2},{-1,       S2}   ,{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},
    {_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},
    {_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},
    {_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2},{_CMD|PF|SABM,S2}},
/* 20 E_STOP */
   {{-1,       S1},   {_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{-1,       S4},
    {_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},
    {_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},
    {_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4},{_CMD|PF|DISC,S4}},
/* 21 */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 22 */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 23 E_T1OUT */
   {{-1, S1},       {_CMD|PF|SABM,S2},{FRMR,S3},      {_CMD|PF|DISC,S4},
    {_CMD|PF|RR,S7},{_CMD|PF|RR, S7}, {_CMD|PF|RR,S7},{RNRc,     S11},
    {RRc,S12},      {RNRc,    S13},   {RNRc,S11},     {RRc,     S12},
    {RRc,S13},      {RNRc,    S14},   {RRc,S15},      {RNRc,    S16}},
/* 24 E_T3OUT */
   {{-1, S1},    {_CMD|SABM,S2},{-1,S3}, {_CMD|DISC,S4},
    {_CMD|RR,S7},{-1,S6},       {-1,S7}, {-1,S8},
    {-1, S9},    {-1,S10},      {-1,S11},{-1,S12},
    {-1, S13},   {-1,S14},      {-1,S15},{-1,S16}},
/* 25 E_N2OVER */
   {{-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1},
    {-1,S1},{-1,S1},{-1,S1},{-1,S1}},
/* 26 E_ILNS */
   {{-1,S1},{-1,S2},{-1,S3},{-1,S4},{-1,S5},{-1,S6},{-1,S7},{-1,S8},
    {-1,S9},{-1,S10},{-1,S11},{-1,S12},{-1,S13},{-1,S14},{-1,S15},{-1,S16}},
/* 27 E_ILNR */
   {{  -1,S1},{  -1,S2},{  -1,S3},{  -1,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3}},
/* 28 E_ILFR */
   {{  -1,S1},{  -1,S2},{  -1,S3},{  -1,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3},
    {FRMR,S3},{FRMR,S3},{FRMR,S3},{FRMR,S3}},

/* 29 E_IDOL */
   {{-1,S1},    {-1,S2}, {-1,S3},    {-1,S4},
    {_CMD|I,S5},{-1,S6}, {_CMD|I,S5},{-1,S8},
    {-1,S9},    {-1,S10},{-1,S11},   {-1,S12},
    {-1,S13},   {-1,S14},{-1,S15},   {-1,S16}}
};

/* ax25tbl.c */
